/*
	Simple case: Enter a file as input and dislay it
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char **fileNames = NULL;

int printFile(const char *fileName)
{
	FILE *fp = (FILE *)NULL;
	if ((fp = fopen(fileName, "r")))
	{
		char buffer[512];
		unsigned int lNumber = 0;
		printf (">>> %s\n",fileName);
		while (fgets(buffer, 512, fp))
		{
			printf("%3d: %s", ++lNumber, buffer);
		}		
		fclose(fp);
		return 0;
	}
	return 1;
}

/* 
	One of the most basic filtering, remove the '/'
*/
void inputFiltering(char *fName)
{
	char buf[256]="";
	char *c = fName, *b = buf;
	for (;*c != '\0';c++)
	{
			if (*c == '/') c++;
			*b++ = *c;
	}
	strncpy(fName, buf, 255);
}


int main(int argc, char *argv[])
{
	short badAlloc = 0;
	// Open the file in the command line
	if (argc > 1)
	{
		const unsigned int nbArgs = argc - 1;
		if ((fileNames = (char **)malloc((nbArgs) * sizeof(char **))) == NULL)
			return 0;		
		for (unsigned int i=0;i<nbArgs;++i)
		{
			// allocate the direction
			if (!(fileNames[i] = (char *)malloc(256 * sizeof(char))))
				badAlloc = 1;
			else
			{
				strncpy(fileNames[i], argv[i+1], 255);
				inputFiltering(fileNames[i]);
			}
		}
		
		if (!badAlloc)
		{
			for (unsigned int i=0;i<nbArgs;++i)
				if (printFile(fileNames[i]))
					printf("Argument error, the given argument is not a readable file (%s).\n", fileNames[i]);
		}
		
		for (unsigned int i=0;i<nbArgs;++i)
			free(fileNames[i]);
		free(fileNames);
	}
	return 0;	
}
