#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>

const char fName[] = "test.file";
const char string[] = "What I want to write";

void handler(int curPid)
{
	fprintf (stdout, "(%d) Start handler...\n",curPid);
	FILE *fp = (FILE *)NULL;
	if ((fp = fopen(fName, "wb")) != (FILE *)NULL)
	{
		fwrite((void *)string, sizeof(char), 20, fp);
		fclose(fp);
	}
	// send the message to the child which should be in fork
	fprintf (stdout, "(%d) Stop handler...\n",curPid);
}

int main(int argc, char *argv[])
{
	pid_t pid = 0;
	// create fork 1
	if (fork())
		return 0;
	
	for (unsigned i=0;i<3;++i) {
		pid = fork();
		if (pid)
		{
			printf ("Run: %d\n",pid);
			handler(pid);
		}
	}
	return 0;
}
