#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>

const char fName[] = "test.file";
const char string[] = "What I want to write";
int fd;


void handler(int curPid)
{
	if (access(fName, W_OK))
			return;	
	fd = open(fName, O_WRONLY | O_CREAT | O_EXCL);
	if (fd)
	{		
		fprintf (stdout, "(%d) Start handler...\n",curPid);
		write(fd, (void *)string, sizeof(char) * 20);
		close(fd);
		fprintf (stdout, "(%d) Stop handler...\n",curPid);
	}
}

int main(int argc, char *argv[])
{
	pid_t pid = 0;
	// create fork 1
	if (fork())
		return 0;
	
	for (unsigned i=0;i<3;++i) {
		pid = fork();
		if (pid)
		{
			printf ("Run: %d\n",pid);
			handler(pid);
		}
	}
	return 0;
}
