/*
 gcc sql_1.c -lmysqlclient -o sql -I/opt/lampp/include/mysql -L/opt/lampp/lib/mysql
*/

#include <mysql.h>
#include <stdio.h>
#include <string.h>



int main(int argc, char *argv[]) 
{
   MYSQL *conn;
   MYSQL_RES *res;
   MYSQL_ROW row;

   char *server = "localhost";
   char *user = "root";
   char *password = "thisismygoodpassword";
   char *database = "bank";
   
	if (argc < 2)
	{
		printf("You should give an entry parameter!\n");
		return 0;		
	}
	
   conn = mysql_init(NULL);
   
   /* Connect to database */
   if (!mysql_real_connect(conn, server,
         user, password, database, 0, NULL, 0)) {
      fprintf(stderr, "%s\n", mysql_error(conn));
      return 0;
   }

   /* send SQL query */
   char query[512];
   char *fmtString = "SELECT * FROM users WHERE firstname LIKE '%s'";
   unsigned int i = 1;
   for (;i<argc;++i)
   {
	   /* No more buffer overflow */
		if ((strlen(argv[i]) + strlen(fmtString)) > 512){
			printf("The entry is too long...\n");
			return 0;		
		}
		char param_escaped[512];
		sprintf(query,fmtString,argv[i]);
		if (mysql_query(conn, query))
		{
		  fprintf(stderr, "%s\n", mysql_error(conn));
		  return 0;
		}		
		res = mysql_use_result(conn);
		/* output fields 1 and 2 of each row */
		while ((row = mysql_fetch_row(res)) != NULL)
		  printf("%s %s\n", row[1], row[2]);  
	}
   

	
	/* Release memory used to store results and close connection */
	mysql_free_result(res);
	mysql_close(conn);
	return 0;
}
